//package com.esmser.tts;
//
//import android.content.Intent;
//import android.media.AudioFormat;
//import android.os.IBinder;
//import android.speech.tts.SynthesisCallback;
//import android.speech.tts.SynthesisRequest;
//import android.speech.tts.TextToSpeech;
//import android.speech.tts.TextToSpeechService;
//
//import com.almagu.ctts.Speech;
//import com.almagu.ctts.SpeechException;
//
///**
// * A text to speech engine that generates speech using Nuance TTS.
// */
//public class AlmaguTtsService extends TextToSpeechService {
//	
//	private static final String TAG = "AlmaguTtsService";
//
//	private volatile boolean mStopRequested = false;
//	private volatile String[] mCurrentLanguage = null;
//
//	private Speech speech;
//	
//    @Override
//    public void onCreate() {
//    	
//    	
//    	speech = new Speech();
//    	try {
//			speech.initialize(this, 48000);
//		} catch (SpeechException e) {
//			// TODO implement + check why not shown in DisplayMessageActivity.onInit(ERROR)
//			speech = null;
//			e.printStackTrace();
//		}
//    	
//        super.onCreate(); 
//    }
//
//    @Override
//    public void onDestroy() {
//    	
//    	if( speech != null ) {
//    		speech.destroy();
//    		speech = null;
//    	}
//    	
//    	super.onDestroy();
//    }
//    
//    @Override
//    public IBinder onBind(Intent intent) {
//    	
//    	// In case we failed to start TTS signal this to client
//    	if( speech == null )
//    		return null;
//    	
//    	return super.onBind(intent);
//    }
//    
//    @Override
//    protected String[] onGetLanguage() {
//        // Note that mCurrentLanguage is volatile because this can be called from multiple threads.
//        return mCurrentLanguage;
//    }
//
//    @Override
//    protected int onIsLanguageAvailable(String lang, String country, String variant) {
//    	
//    	if( lang.equals("heb") ) 
//    		return TextToSpeech.LANG_AVAILABLE;
//    	
//		if( country.equals("ISR") )
//			return TextToSpeech.LANG_COUNTRY_AVAILABLE;
//		
//    	return TextToSpeech.LANG_NOT_SUPPORTED;
//    }
//
//    /*
//     * Note that this method is synchronized, as is onSynthesizeText because
//     * onLoadLanguage can be called from multiple threads (while onSynthesizeText
//     * is always called from a single thread only).
//     */
//    @Override
//    protected synchronized int onLoadLanguage(String lang, String country, String variant) {
//        return onIsLanguageAvailable(lang, country, null);
//    }
//
//    @Override
//    protected void onStop() {
//    	// XXX: implement
//    	mStopRequested = true;
//    	return;
//    }
//
//    @Override
//    protected synchronized void onSynthesizeText(final SynthesisRequest request, final SynthesisCallback callback) {
//    	
//    	mStopRequested = false;
//    	
//        // There is no guarantee that there would have been a prior call to this function.
//        int loadResult = onLoadLanguage(request.getLanguage(), request.getCountry(), request.getVariant());
//
//        // We might get requests for a language we don't support
//        if (loadResult == TextToSpeech.LANG_NOT_SUPPORTED) {
//            callback.error();
//            return;
//        }
//        
//        String voiceName = "Sivan";
//        Float speechRate = 1.0f;
//        String text = request.getText();
//        try {
//			byte[] audioData = speech.synth(voiceName, speechRate, text);
//			
//			callback.start(48000, AudioFormat.ENCODING_PCM_16BIT, 1 /* Number of channels.*/);
//			
//	        final int maxBufferSize = callback.getMaxBufferSize();
//	        int offset = 0;
//	        while ((offset < audioData.length) && !mStopRequested) {
//	            int bytesToWrite = Math.min(maxBufferSize, audioData.length - offset);
//	            callback.audioAvailable(audioData, offset, bytesToWrite);
//	            offset += bytesToWrite;
//	        }
//	        
//	        callback.done();
//	        
//		} catch (SpeechException e) {
//			// TODO IMPLEMENT
//			e.printStackTrace();
//            callback.error();
//            return;
//		}
//    }
//
//}
