//package com.esmser.tts;
//
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.Locale;
//
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//
//import android.content.Context;
//import android.content.Intent;
//import android.content.SharedPreferences;
//import android.content.SharedPreferences.Editor;
//import android.os.Bundle;
//import android.preference.PreferenceManager;
//import android.speech.tts.TextToSpeech;
//import android.speech.tts.TextToSpeech.OnInitListener;
//import android.speech.tts.UtteranceProgressListener;
//
//import com.esmser.ui.DisplayMessageActivity;
//
//enum SettingsChanges {
//	CHANGED_NONE,
//	CHANGED_ENGINE,
//	CHANGED_LANGUAGE;
//}
//
//// XXX: Make some methods static !!!
//public enum AndroidTtsEngine implements OnInitListener {
//
//	INSTANCE; // Singleton
//	
//	private static final Logger LOG = LoggerFactory.getLogger(AndroidTtsEngine.class);
//	
//	private Context context;
//	
//	private OnInitListener observer;
//	private TextToSpeech myTts = null;
//	private String currentLanguage = "";
//	private String currentCountry = "";
//	private String currentEngine = "";
//	private boolean isInitialized = false;
//
//	private final UtteranceProgressListener listener = new UtteranceProgressListener() {
//		
//		@Override
//		public void onStart(String utteranceId) {
//		}
//		
//		@Override
//		public void onError(String utteranceId) {
//			sendBroadcast();		
//		}
//
//		@Override
//		public void onDone(String utteranceId) {
//			sendBroadcast();
//		}
//
//		private void sendBroadcast() {
//			if( context != null )
//				context.sendBroadcast(new Intent(DisplayMessageActivity.TTS_FINISHED_ACTION));
//		}
//	};
//
//	private HashMap<String, String> ttsParameters;
//	
//	
//	public synchronized void create(Context context, OnInitListener observer) {
//		this.isInitialized = false;
//		this.context = context;
//		this.observer = observer;
//		this.myTts = createEngine(context, observer, this.listener);
//	}
//
//	@Override
//	public void onInit(int status) {
//		
//		if (status != TextToSpeech.SUCCESS) {
//			LOG.error("Text To Speech initialization failed");
//			observer.onInit(TextToSpeech.ERROR);
//			return;
//		}
//
//		int setLanguageResult = AndroidTtsEngine.INSTANCE.setLanguage(new Locale(this.currentLanguage, this.currentCountry));
//		if(setLanguageResult < TextToSpeech.LANG_AVAILABLE) {
//			LOG.error("Text To Speech can not set language " + this.currentLanguage);
//			observer.onInit(TextToSpeech.ERROR);
//			return;
//		}
//
//		this.isInitialized = true;
//		observer.onInit(TextToSpeech.SUCCESS);
//	}
//	
//	public synchronized boolean hasTtsSettings(Context context) {
//		// XXX: TTS
//		return false;
////		
////		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(context);
////		return !TextUtils.isEmpty(preferences.getString("engine", ""));
//	}
//	
//	public synchronized boolean isInitialized() {
//		return this.isInitialized;
//	}
//	
//	public static int findBestMatchIndex(TtsLanguage[] ttsLanguagesData) {
//		
//		Locale defaultLocale = Locale.getDefault();
//		Locale usLocale = Locale.US;
//		int sameLanguageIndex = -1;
//		int sameCountryIndex = -1;
//		int engUsaIndex = -1;
//		
//		for (int index = 0; index < ttsLanguagesData.length; index++) {
//			Locale current = ttsLanguagesData[index].getLocale();
//			
//			// almost full match
//			if( current.getLanguage().equals(defaultLocale.getISO3Language()) && current.getCountry().equals(defaultLocale.getISO3Country()) )
//				return index;
//			
//			if( current.getLanguage().equals(usLocale.getISO3Language()) && current.getCountry().equals(usLocale.getISO3Country()) ) {
//				engUsaIndex = index;
//			}
//			else if( current.getLanguage().equals(defaultLocale.getISO3Language()) ) { 
//				sameLanguageIndex = index;
//			}
//			else if( current.getCountry().equals(defaultLocale.getISO3Country()) ) { 
//				sameCountryIndex = index;
//			}
//		}
//
//		if( sameLanguageIndex != -1)
//			return sameLanguageIndex;
//
//		if( sameCountryIndex != -1)
//			return sameCountryIndex;
//
//		if( engUsaIndex != -1)
//			return engUsaIndex;
//		
//		return ttsLanguagesData.length > 0 ? 0 : -1;
//	}
//
//	public int findSelectedLanguageIndex(Context context, TtsLanguage[] ttsLanguagesData) {
//		
//		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(context);
//		String language = preferences.getString("language", "");
//		String country = preferences.getString("country", "");
//
//		for (int index = 0; index < ttsLanguagesData.length; index++) {
//			Locale locale = ttsLanguagesData[index].getLocale();
//			if( locale.getLanguage().equals(language) && locale.getCountry().equals(country) )
//				return index;
//		}
//		
//		return -1;
//	}
//	
//	public synchronized void saveSelectedLanguage(Context context, TtsLanguage data) {
//		
//		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(context);
//		Locale locale = data.getLocale();
//		
//		Editor editor = preferences.edit();
//		editor.putString("engine", data.getEngine());
//		editor.putString("language", locale.getLanguage());
//		editor.putString("country", locale.getCountry());
//		editor.commit();
//	}
//
//	public synchronized void playOrPauseMessage(ArrayList<Bundle> conversation, boolean playAll) {
//
//		if( myTts == null )
//			return;
//		
//		if( myTts.isSpeaking() ) {
//			stopMessage();
//		}
//		else {
//			// XXX: support mark as played for prompts actually heard using text_id
//			String phrase = PhraseBuilder.buildAll(context, getSelectedLocale(), packageName, conversation, playAll);
//			ttsParameters = new HashMap<String, String>();
//			
//			ttsParameters.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, "utt");
//			myTts.speak(phrase, TextToSpeech.QUEUE_FLUSH, ttsParameters);
//		}
//	}
//	
//	public synchronized void stopMessage() {
//		
//		if( (myTts == null) || !myTts.isSpeaking() )
//			return;
//		
//		myTts.stop();
//	}
//
//	public synchronized int setLanguage(Locale locale) {
//		
//		if( myTts == null ) {
//			return TextToSpeech.LANG_MISSING_DATA;
//		}
//		
//		return myTts.setLanguage(locale);
//	}
//	
//	public synchronized void shutdown() {
//		if( myTts != null ) {
//			myTts.shutdown();
//			myTts = null;
//		}
//	}
//
//	private TextToSpeech createEngine(Context context, OnInitListener observer, UtteranceProgressListener listener) {
//		
//		LOG.debug("createEngine as " + this.currentEngine);
//		
//		// remove old instance
//		shutdown();
//		
//		TextToSpeech textToSpeech = new TextToSpeech(context, this, this.currentEngine);
//		textToSpeech.setOnUtteranceProgressListener(listener);
//		return textToSpeech;
//	}
//
//	private Locale getSelectedLocale() {
//		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this.context);
//		return new Locale(preferences.getString("language", ""), preferences.getString("country", ""));
//	}
//
//}
